#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "appli.h"
#include "tcp_like.h"

#define NB_ITERATIONS 2

static void *helloworld(void *client);
static void *pingpong(void *client);

void *appli(void *client){
  /* helloworld et pingpong sont deux tests indpendants */
  /* on ne doit avoir qu'un seul test activ  la fois */

  //helloworld(client);
  pingpong(client);
  return NULL;
}

static void *helloworld(void *client){
  /* Exemple classique du 'hello world"*/

  char *msg = "hello world";
  int msg_len = strlen(msg);

  char *buf = malloc(msg_len+1);
  memset(buf, '0', msg_len);

  if(*(int *)client){
    /* client */
    strncpy(buf, msg, strlen(msg));

    tcp_like_connect();
    tcp_like_send(buf, msg_len);
    {
      int i;
      printf("J'envoie [");
      for(i = 0; i < msg_len; i++)
        printf("%c", buf[i]);
      printf("]\n");
    }
    //    sleep(3);
    tcp_like_disconnect();

  } else {
    /* server */
    tcp_like_accept();

    tcp_like_recv(buf, msg_len);
    buf[strlen(msg)] = '\0';
    printf("J'ai reu [%s]\n", buf);
  }
  tcp_like_exit();
  free(buf);
  return NULL;
}

static void *pingpong(void *client){
  int k;
  char *msg = "abc";
  int msg_len = strlen(msg);
  void *buf = malloc(msg_len+1);
  memset(buf, '0', msg_len);

  if(*(int *)client){
    /* client */
    strncpy(buf, msg, strlen(msg));

    tcp_like_connect();

    for(k = 0; k < NB_ITERATIONS; k++) {
      tcp_like_send(buf, msg_len);

      memset(buf, '0', msg_len);
      tcp_like_recv(buf, msg_len);

      ((char *)buf)[msg_len] = '\0';
      printf("buf = [%s]\n", (char *)buf);
    }
    tcp_like_disconnect();

  } else {
    /* server */

    tcp_like_accept();

    for(k = 0; k < NB_ITERATIONS; k++) {
      tcp_like_recv(buf, msg_len);
      tcp_like_send(buf, msg_len);
    }
  }

  tcp_like_exit();
  free(buf);
  return NULL;
}

