#include "timeout.h"
#include "my_signal.h"

struct sigaction actions;
sigset_t sig_mask;
int init_signals(){
  sigemptyset(&sig_mask);
  sigaddset(&sig_mask,SIGALRM);

  /* Configuration du handler de SIGALRM */

  memset(&actions, 0, sizeof(actions));
  sigemptyset(&actions.sa_mask);
  actions.sa_flags=0;
  actions.sa_handler=timeout_handler;
  sigaction(SIGALRM,&actions,NULL);

  return 0;
}

int my_select(int fd){
  fd_set read_fd_set;
  struct timespec tmp_time;
  int i;
  sigset_t tmp_sig_mask;
  
  sigfillset(&tmp_sig_mask);

  FD_ZERO (&read_fd_set);
  FD_SET (fd,&read_fd_set);

  tmp_time.tv_sec=0;
  tmp_time.tv_nsec=1000*1000*2;
  
  i = pselect (FD_SETSIZE, &read_fd_set, NULL, NULL, &tmp_time, &tmp_sig_mask);

  return i;
}
