#include "timeout.h"
#include <pthread.h>
#include "global.h"
#include "my_signal.h"
#include "tcp_like_remettre.h"

struct itimerval itimer;
int already_timer,nb_timers;

 double initial_time,next_alarm;
struct my_evt *evt_list,*evt_cur;

int timeout_init_layer(){
  already_timer=0;
  nb_timers=0;
  evt_list=NULL;
  evt_cur=NULL;
  
  return 0;
}

int timeout_set_alarm(int ntrame, int type){
  /* dclencher un chronomtre pour l'emission de la trame n ntrame */
  struct my_evt *evt_tmp;
  struct timeval local_time;

  sigset_t old_sig_mask;
  pthread_sigmask (SIG_SETMASK, &sig_mask, &old_sig_mask );

  gettimeofday(&local_time,NULL);
  evt_tmp=(struct my_evt *)calloc(1,sizeof(struct my_evt));
  if(evt_cur!=NULL){
    evt_cur->next=evt_tmp;
    evt_cur=evt_cur->next;
  }else{
    evt_cur=evt_tmp;
    evt_list=evt_cur;
  }
  evt_cur->alarm_time=(double)local_time.tv_sec+((double)local_time.tv_usec/1000000)-initial_time+TIME_OUT/1000000;
  evt_cur->next=NULL;
  evt_cur->ntrame=ntrame;
  evt_cur->type=type;
  evt_cur->ok=0;
  nb_timers++;


  if(nb_timers==1){
    itimer.it_interval.tv_sec=0;
    itimer.it_interval.tv_usec=0;
    itimer.it_value.tv_sec=0;
    itimer.it_value.tv_usec=TIME_OUT;
    setitimer(ITIMER_REAL, &(itimer), NULL);
    already_timer=1;
  }
  pthread_sigmask ( SIG_SETMASK, &old_sig_mask,NULL );

  return 0;
}


void timeout_handler(int signum){
  /* gestionnaire du SIGALARM gnr lors de l'expiration d'un timer */

  struct timeval local_time;
  struct my_evt *tmp_evt;
  double next_alarm;
  sigset_t old_sig_mask;
  pthread_sigmask (SIG_SETMASK, &sig_mask, &old_sig_mask );

  gettimeofday(&local_time,NULL);
  already_timer=0;
  next_alarm=evt_list->alarm_time-(((double)local_time.tv_sec+((double)local_time.tv_usec/1000000)-initial_time));
  while((evt_list != NULL) && ((next_alarm <= 0) || (evt_list->ok == 1))){
    if(evt_list->ok==0){
      /* appeler le bon handler pour la rmission */
      tcp_like_remettre_trame(evt_list->ntrame);
    }

    tmp_evt=evt_list;
    evt_list=evt_list->next;
    free(tmp_evt);
    nb_timers--;
    if(evt_list==NULL){
      already_timer=0;
      evt_cur=NULL;
    }
    if((evt_list!=NULL)&&(already_timer==0)){
      gettimeofday(&local_time,NULL);
      next_alarm=evt_list->alarm_time-(((double)local_time.tv_sec+((double)local_time.tv_usec/1000000)-initial_time));
    }
  }

  if((evt_list!=NULL)&&(already_timer==0)){
    itimer.it_interval.tv_sec=0;
    itimer.it_interval.tv_usec=0;
    itimer.it_value.tv_sec=0;
    itimer.it_value.tv_usec=next_alarm*1000000;
    already_timer=1;
    setitimer(ITIMER_REAL, &(itimer), NULL);
  }

  pthread_sigmask ( SIG_SETMASK, &old_sig_mask,NULL );
}


int timeout_init_clock(){
  struct timeval local_time;
  gettimeofday(&local_time,NULL);
  initial_time=(double)local_time.tv_sec+((double)local_time.tv_usec/1000000);
  return 0;
}


int timeout_clean(int trame_num){
  sigset_t old_sig_mask;
  struct my_evt *tmp_evt;
  pthread_sigmask ( SIG_SETMASK, &sig_mask, &old_sig_mask );
  tmp_evt=evt_list;
  while((tmp_evt!=NULL)&&(tmp_evt->ntrame!=trame_num)){
    tmp_evt=tmp_evt->next;
  }
  if(tmp_evt==NULL){
    printf("Erreur : La trame n %d n'existe pas dans la structure de gestion des timeouts \n",trame_num);
    exit(-1);
  }
  tmp_evt->ok=1;
  pthread_sigmask ( SIG_SETMASK, &old_sig_mask,NULL );

  return 0;
}
