#ifndef TRAME_H
#define TRAME_H

#define LONGUEUR_DONNEES 50

#include "netinet/in.h"

enum type_trame{
  data,
  ack,
  requete_connexion /*(syn)*/,
  connexion_succes /*(syn+ack)*/,
  connexion_rejet /*(RST)*/,
  sack,
  fin,
  fin_ack
};

struct trame{
  enum type_trame type;

  int flag_emis;

  union trame_info{
    struct{
      int numero_trame;
      char data[LONGUEUR_DONNEES];
    } data;

    struct{
      int numero_ack;
    } ack;

    // struct{}requete_connexion;

    struct{
      int cnx_nb;
    }connexion_succes;

    //struct connexion_rejet{};

    struct{
      int cnx_nb;
    }sack;

    struct{
      int seq_number;
    }fin;


  }info;
};

extern void init_trame(void);
extern struct trame *creer_trame_donnees(int numero_trame, void *buf, int taille);
extern struct trame *creer_ack(int numero_ack);
extern struct trame *creer_demande_cnx(void);
extern struct trame *creer_succes_cnx(int cnx_nb);
extern struct trame *creer_rejet_cnx(void);
extern struct trame *creer_sack(int cnx_nb);
extern struct trame *creer_trame_de_reception(void);
extern struct trame *creer_fin(int seq_number);
extern struct trame *creer_fin_ack(void);

extern void emettre_trame(struct trame *trame, int sock, struct sockaddr_in *si_other);
extern void envoyer_trame_retardee(int sock, struct sockaddr_in *si_other);
extern void detruire_trame(struct trame *trame);

#endif
